package com.stryker.cmf.accountrolebean;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.persistence.EntityExistsException;
/**
 * 
 * @author tony.mattas
 *
 */
@Stateless
public class AccountMgrBean implements AccountMgr {
	@EJB UsersFacadeLocal userfacade;
	@EJB GroupsFacadeLocal groupsfacade;
	
	public void adduser(String username, String password) throws EntityExistsException {
		Users iusername = userfacade.findById(username);
		/* Check for data sanity before hitting the DB adapter to prevent internal error */
		if (iusername != null) { 
			throw new EntityExistsException();
		}
		/* Now we'll create a new User object, since it currently is null */
		iusername = new Users();
		//TODO - Why does it get disconnected from database
		iusername.setUsername(username);
		try {
			iusername.setPassword(hash(password));
		} catch (NoSuchAlgorithmException e1) {
			/* Throw a generic exception upwards */
			throw new RuntimeException();
		}
		try {
			userfacade.save(iusername);
		} catch (RuntimeException e) {
			//Pass exception onto caller
			throw e;
		}
	}
	/**
	 * Generates a MD5 Hash
	 * @param password Plain text password
	 * @return Hashed Password
	 * @throws NoSuchAlgorithmException 
	 * @throws NoSuchAlgorithmException
	 */
	private String hash(String password) throws NoSuchAlgorithmException {
		/* String to return */
		String hashed = null;
		BigInteger hash;
		try {
			/* Hashing algorithm */
			MessageDigest md5 = MessageDigest.getInstance("MD5");
			md5.update(password.getBytes());
			hash = new BigInteger(1, md5.digest());
			hashed = hash.toString(16);
			/* Acount for varying string lengths */
			if (hashed.length() < 32) {
				hashed = 0 + hashed;
			}
		} catch (NoSuchAlgorithmException e) {
			/* Throw up to parent */
			throw e;
		}
		return hashed;
	}

	public void editgroup(String user, String group) throws RuntimeException {
		Users username = new Users();
		username = userfacade.findById(user);
		// Check to see if the user role already exists.
		Groups groupname = groupsfacade.findById(username.getUsername()); 
		// If it does try to update
		if (groupname != null) {
			groupname = new Groups(username.getUsername(), username, group);
			try {
				groupsfacade.update(groupname);
			} catch (RuntimeException e) {
				throw e;
			}	
		// Otherwise add the group.
		} else {
			groupname = new Groups(username.getUsername(), username, group);
			try {
				groupsfacade.save(groupname);
			} catch (RuntimeException e) {
				throw e;
			}
		}
	}
}
	

