package com.stryker.cmf.accountrolebean;

import java.util.List;
import java.util.logging.Level;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 * Facade for entity Groups.
 * 
 * @see com.stryker.cmf.accountrolebean.Groups
 * @author MyEclipse Persistence Tools
 */
@Stateless
public class GroupsFacade implements GroupsFacadeLocal {
	// property constants
	public static final String GROUPNAME = "groupname";

	@PersistenceContext
	private EntityManager entityManager;

	public void save(Groups transientInstance) {
		EntityManagerHelper.log("saving Groups instance", Level.INFO, null);
		try {
			entityManager.persist(transientInstance);
			EntityManagerHelper.log("save successful", Level.INFO, null);
		} catch (RuntimeException re) {
			EntityManagerHelper.log("save failed", Level.SEVERE, re);
			throw re;
		}
	}

	public void delete(Groups persistentInstance) {
		EntityManagerHelper.log("deleting Groups instance", Level.INFO, null);
		try {
			entityManager.remove(persistentInstance);
			EntityManagerHelper.log("delete successful", Level.INFO, null);
		} catch (RuntimeException re) {
			EntityManagerHelper.log("delete failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Groups update(Groups detachedInstance) {
		EntityManagerHelper.log("updating Groups instance", Level.INFO, null);
		try {
			Groups result = entityManager.merge(detachedInstance);
			EntityManagerHelper.log("update successful", Level.INFO, null);
			return result;
		} catch (RuntimeException re) {
			EntityManagerHelper.log("update failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Groups findById(String id) {
		EntityManagerHelper.log("finding Groups instance with id: " + id,
				Level.INFO, null);
		try {
			Groups instance = entityManager.find(Groups.class, id);
			return instance;
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find failed", Level.SEVERE, re);
			throw re;
		}
	}

	@SuppressWarnings("unchecked")
	public List<Groups> findByProperty(String propertyName, Object value) {
		EntityManagerHelper.log("finding Groups instance with property: "
				+ propertyName + ", value: " + value, Level.INFO, null);
		try {
			String queryString = "select model from Groups model where model."
					+ propertyName + "= :propertyValue";
			return entityManager.createQuery(queryString).setParameter(
					"propertyValue", value).getResultList();
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find by property name failed",
					Level.SEVERE, re);
			throw re;
		}
	}

	public List<Groups> findByGroupname(Object groupname) {
		return findByProperty(GROUPNAME, groupname);
	}

	@SuppressWarnings("unchecked")
	public List<Groups> findAll() {
		EntityManagerHelper.log("finding all Groups instances", Level.INFO,
				null);
		try {
			String queryString = "select model from Groups model";
			return entityManager.createQuery(queryString).getResultList();
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find all failed", Level.SEVERE, re);
			throw re;
		}
	}
}